package BT_2010;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import javax.bluetooth.*;
import javax.microedition.io.Connector;
import javax.microedition.io.StreamConnection;
import javax.microedition.lcdui.*;
import javax.microedition.midlet.*;

/**
 * @author hector
 */

public class BT_2010 extends MIDlet implements CommandListener, DiscoveryListener {
    public Form formulario;
    public List lista;
    public List acciones;
    private static final UUID SERVICE_UUID = new UUID(0x1101);
    public static final UUID[] SERVICIOS = new UUID[]{SERVICE_UUID};
    public String Url;
    public RemoteDevice device;
    public Command buscar = new Command("Buscar", Command.OK, 0);
    public Command acabar = new Command("Salir ", Command.EXIT, 4);
    public Display display;
    private AbrirPuerta open;
    private Ascensor  ascen;
    private Luz light;
    private DiscoveryAgent discoveryAgent;
    private StreamConnection connection;
    public DataOutputStream out;
    public DataInputStream in;

    public void startApp() {
        try {
            discoveryAgent = LocalDevice.getLocalDevice().getDiscoveryAgent();
        } catch (BluetoothStateException e) {
            e.printStackTrace();
        }
        display = Display.getDisplay(this);
        formulario = new Form("BT_2010");
        formulario.addCommand(buscar);
        formulario.addCommand(acabar);
        formulario.setCommandListener(this);
        display.setCurrent(formulario);
    }

    public void pauseApp() {
    }

    public void destroyApp(boolean unconditional) {
    }

    public void commandAction(Command c, Displayable d) {
        if (c==buscar){
            try {
                discoveryAgent.startInquiry(DiscoveryAgent.GIAC, this);
            } catch (BluetoothStateException ex) {
                ex.printStackTrace();
            }
        }  else if (c == acabar) { //COMANDO QUE FINALIZA LA APLICACION
            destroyApp(false);
            notifyDestroyed();
        } else if (c== List.SELECT_COMMAND & d == lista){
            Acciones();
        } else if (c == List.SELECT_COMMAND & d == acciones){
            if (acciones.getString(acciones.getSelectedIndex()).equals("Seleccionar todas")){
                light = new Luz();
                light.start();
                ascen = new Ascensor();
                ascen.start();
                open = new AbrirPuerta();
                open.start();
            } else if(acciones.getString(acciones.getSelectedIndex()).equals("Abrir puerta")){
                open = new AbrirPuerta();
                open.start();
            } else if(acciones.getString(acciones.getSelectedIndex()).equals("Llamar ascensor")){
                ascen = new Ascensor();
                ascen.start();
            } else if(acciones.getString(acciones.getSelectedIndex()).equals("Encender luz")){
                light = new Luz();
                light.start();
            }
        }
    }

    public void deviceDiscovered(RemoteDevice arg0, DeviceClass arg1) {
    device = arg0;
    try {
        discoveryAgent.searchServices(null, SERVICIOS, device, this);
    } catch (BluetoothStateException e) {
        e.printStackTrace();
    }
    }

    public void inquiryCompleted(int discType) {
        switch (discType) {
        case DiscoveryListener.INQUIRY_COMPLETED: System.out.println("Busqueda de dispositivos concluida con normalida");
        break;
        case DiscoveryListener.INQUIRY_TERMINATED: System.out.println("Busqueda de" + "dispositivos cancelada");
        break;
        case DiscoveryListener.INQUIRY_ERROR: System.out.println("Busqueda de dispositivos finalizada debido a");
        break;
        }
    }

    public void serviceSearchCompleted(int transID, int respCode) {
        switch (respCode) {
        case DiscoveryListener.SERVICE_SEARCH_COMPLETED: System.out.println("Busqueda completada " + "con normalidad");
        break;
        case DiscoveryListener.SERVICE_SEARCH_TERMINATED: System.out.println("Busqueda cancelada");
        break;
        case DiscoveryListener.SERVICE_SEARCH_DEVICE_NOT_REACHABLE: System.out.println("Dispositivo no alcanzable");
        break;
        case DiscoveryListener.SERVICE_SEARCH_NO_RECORDS: System.out.println("No se encontraron registros" + " de servicio");
        break;
        case DiscoveryListener.SERVICE_SEARCH_ERROR: System.out.println("Error en la busqueda");
        break;
        }
    }

    public void servicesDiscovered(int arg0, ServiceRecord[] servRecord) {
       ServiceRecord service = servRecord[0];
       Url = service.getConnectionURL(ServiceRecord.NOAUTHENTICATE_NOENCRYPT, false);
       lista = new List("Dispositivos", List.IMPLICIT);
       try {
            lista.append(device.getFriendlyName(true) + "  \n" +device.getBluetoothAddress() , null);
       } catch (IOException ex) {
            Alert alerta = new Alert("ERROR","No encuentra dispositivos", null, AlertType.ERROR);
            display.setCurrent(alerta);
            ex.printStackTrace();
       }
       lista.addCommand(buscar);
       lista.addCommand(acabar);
       lista.setCommandListener(this);
       display.setCurrent(lista);
    }

    private void Acciones (){
            acciones = new List("Opciones", List.IMPLICIT);
            acciones.append("Seleccionar todas", null);
            acciones.append("Abrir puerta", null);
            acciones.append("Llamar ascensor", null);
            acciones.append("Encender luz", null);
            acciones.addCommand(acabar);
            acciones.setCommandListener(this);
            display.setCurrent(acciones);
    }
    
private class AbrirPuerta extends Thread {
public AbrirPuerta() {}
public void run(){
            try {
                connection = (StreamConnection) Connector.open(Url);
                out = connection.openDataOutputStream();
                in = connection.openDataInputStream();            
                out.write("AT+ZV GPIOWrite 10 1\n".getBytes());
                out.flush();
                wait(10000);
                out.write("AT+ZV GPIOWrite 10 0\n".getBytes());
                out.flush();
                in.close();
                out.close();
                connection.close();
            } catch (InterruptedException ex) {
                ex.printStackTrace();
            } catch (IOException ex) {
                ex.printStackTrace();
            }
        Acciones();
}
}

private class Ascensor extends Thread {
public Ascensor() {}
public void run(){
        try {
            connection = (StreamConnection) Connector.open(Url);
            out = connection.openDataOutputStream();
            in = connection.openDataInputStream();
            out.write("AT+ZV GPIOWrite 05 1\n".getBytes());
            out.flush();
            wait(100);
            out.write("AT+ZV GPIOWrite 05 0\n".getBytes());
            out.flush();
            in.close();
            out.close();
            connection.close();        
        }   catch (InterruptedException ex) {
                ex.printStackTrace();
            } catch (IOException ex) {
            ex.printStackTrace();
        }
       Acciones ();
}
}
private class Luz extends Thread {
public Luz() {}
public void run(){
       try {
            connection = (StreamConnection) Connector.open(Url);
            out = connection.openDataOutputStream();
            in = connection.openDataInputStream();
            out.write("AT+ZV GPIOWrite 07 1\n".getBytes());
            out.flush();
            wait(100);
            out.write("AT+ZV GPIOWrite 07 0\n".getBytes());
            out.flush();
            in.close();
            out.close();
            connection.close();
        }   catch (InterruptedException ex) {
                ex.printStackTrace();
            } catch (IOException ex) {
            ex.printStackTrace();
        }
       Acciones ();
}
}
}